--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

with Nomo.Interpreter.Conditions_Base.Logging;

with Nomo.Interpreter.Storages.Writing;

package body Nomo.Interpreter.Perception_Conditions.Logging is

   use Conditions_Base.Logging;

   procedure Log_Full (This       : in Perception_Condition;
                       Buffer_Ptr : not null access Storages.Full_Rule_Storage) is
      use Storages.Writing;
   begin
      Log_Full (Condition_Base (This), Buffer_Ptr);
      Set_External_Condition (Buffer_Ptr.all, This.Input_Premise, This.Input_Type);
   end Log_Full;

   procedure Log_Partial (This       : in Perception_Condition;
                          Buffer_Ptr : not null access Storages.Full_Rule_Storage) is
   begin
      Log_Partial (Condition_Base (This), Buffer_Ptr);
   end Log_Partial;

end Nomo.Interpreter.Perception_Conditions.Logging;
